// Generated by CoffeeScript 1.3.3
(function() {
  'use strict';

  var async, categories, destroyFile, flatten, frameworkChocies, fs, fs_utils, generateFile, generatorChoices, generators, getGenerator, helpers, inflection, logger, mkdirp, scaffold, sysPath;

  async = require('async');

  fs = require('fs');

  inflection = require('inflection');

  mkdirp = require('mkdirp');

  sysPath = require('path');

  helpers = require('../helpers');

  logger = require('../logger');

  fs_utils = require('../fs_utils');

  flatten = function(array) {
    return array.reduce(function(acc, elem) {
      return acc.concat(Array.isArray(elem) ? flatten(elem) : [elem]);
    }, []);
  };

  categories = {
    backbone: {
      'model-test': 'javascripts',
      model: 'javascripts',
      'collection-test': 'javascripts',
      collection: 'javascripts',
      template: 'templates',
      style: 'stylesheets',
      'view-test': 'javascripts',
      view: 'javascripts',
      scaffold: 'javascripts'
    },
    chaplin: {
      'controller-test': 'javascripts',
      controller: 'javascripts',
      'model-test': 'javascripts',
      model: 'javascripts',
      'collection-test': 'javascripts',
      collection: 'javascripts',
      template: 'templates',
      style: 'stylesheets',
      'view-test': 'javascripts',
      view: 'javascripts',
      'collection-view-test': 'javascripts',
      'collection-view': 'javascripts',
      'page-view-test': 'javascripts',
      'page-view': 'javascripts',
      scaffold: 'javascripts'
    }
  };

  frameworkChocies = function() {
    return Object.keys(categories).join(', ');
  };

  generatorChoices = function(framework) {
    return Object.keys(categories[framework] || {}).join(', ');
  };

  generators = function(config, generator) {
    return {
      backbone: {
        'model-test': function(name, pluralName) {
          return [sysPath.join(config.paths.test, 'models', "" + name + "_test")];
        },
        model: function(name, pluralName) {
          return [sysPath.join(config.paths.app, 'models', "" + name)].concat(generator('model-test', name, pluralName));
        },
        'collection-test': function(name, pluralName) {
          return [sysPath.join(config.paths.test, 'models', "" + pluralName + "_test")];
        },
        collection: function(name, pluralName) {
          return [sysPath.join(config.paths.app, 'models', "" + pluralName)].concat(generator('collection-test', name, pluralName));
        },
        template: function(name) {
          return [sysPath.join(config.paths.app, 'views', 'templates', "" + name)];
        },
        style: function(name) {
          return [sysPath.join(config.paths.app, 'views', 'styles', "" + name)];
        },
        'view-test': function(name, pluralName) {
          return [sysPath.join(config.paths.test, 'views', "" + name + "_view_test")];
        },
        view: function(name, pluralName) {
          return [sysPath.join(config.paths.app, 'views', "" + name + "_view")].concat(generator('view-test', name, pluralName), generator('template', name), generator('style', name));
        },
        scaffold: function(name, pluralName) {
          return generator('model', name, pluralName).concat(generator('view', name, pluralName));
        }
      },
      chaplin: {
        'controller-test': function(name, pluralName) {
          return [sysPath.join(config.paths.test, 'controllers', "" + pluralName + "_controller_test")];
        },
        controller: function(name, pluralName) {
          return [sysPath.join(config.paths.app, 'controllers', "" + pluralName + "_controller")].concat(generator('controller-test', name, pluralName));
        },
        'model-test': function(name, pluralName) {
          return [sysPath.join(config.paths.test, 'models', "" + name + "_test")];
        },
        model: function(name, pluralName) {
          return [sysPath.join(config.paths.app, 'models', "" + name)].concat(generator('model-test', name, pluralName));
        },
        'collection-test': function(name, pluralName) {
          return [sysPath.join(config.paths.test, 'models', "" + pluralName + "_test")];
        },
        collection: function(name, pluralName) {
          return [sysPath.join(config.paths.app, 'models', "" + pluralName)].concat(generator('collection-test', name, pluralName));
        },
        template: function(name) {
          return [sysPath.join(config.paths.app, 'views', 'templates', "" + name)];
        },
        style: function(name) {
          return [sysPath.join(config.paths.app, 'views', 'styles', "" + name)];
        },
        'view-test': function(name, pluralName) {
          return [sysPath.join(config.paths.test, 'views', "" + name + "_view_test")];
        },
        view: function(name, pluralName) {
          return [sysPath.join(config.paths.app, 'views', "" + name + "_view")].concat(generator('view-test', name, pluralName), generator('template', name));
        },
        'collection-view-test': function(name, pluralName) {
          return [sysPath.join(config.paths.test, 'views', "" + pluralName + "_view_test")];
        },
        'collection-view': function(name, pluralName) {
          return [sysPath.join(config.paths.app, 'views', "" + pluralName + "_view")].concat(generator('collection-view-test', name, pluralName));
        },
        'page-view-test': function(name, pluralName) {
          return [sysPath.join(config.paths.test, 'views', "" + name + "_page_view_test")];
        },
        'page-view': function(name, pluralName) {
          return [sysPath.join(config.paths.app, 'views', "" + name + "_page_view")].concat(generator('page-view-test', name, pluralName), generator('template', "" + name + "_page"), generator('style', "" + name + "_page"));
        },
        scaffold: function(name, pluralName) {
          return generator('controller', name, pluralName).concat(generator('model', name, pluralName), generator('view', name, pluralName), generator('collection-view', name, pluralName));
        }
      }
    };
  };

  getGenerator = function(config, plugins) {
    var framework, generator, generatorMap, getExtension, getGeneratorMap;
    framework = config.framework || 'backbone';
    if (categories[framework] == null) {
      return logger.error("Framework " + framework + " isn't supported. Use one of: " + (frameworkChocies()));
    }
    getExtension = function(type) {
      var category, _ref, _ref1, _ref2;
      category = (_ref = categories[framework]) != null ? _ref[type] : void 0;
      if (category != null) {
        return (_ref1 = (_ref2 = config.files[category]) != null ? _ref2.defaultExtension : void 0) != null ? _ref1 : '';
      } else {
        logger.error("Generator " + type + " isn't supported. Use one of: " + (generatorChoices(framework)) + ".");
        return '';
      }
    };
    generatorMap = null;
    getGeneratorMap = function() {
      return generatorMap != null ? generatorMap : generatorMap = generators(config, generator);
    };
    generator = function(type, name, pluralName) {
      var configGenerator, data, dataGenerator, extension, getData, getPaths, nonStrings, paths, plugin, strings, _ref, _ref1, _ref2, _ref3;
      configGenerator = (_ref = config.generators) != null ? _ref[type] : void 0;
      getData = function(item) {
        if (typeof item === 'function') {
          return item(name, pluralName);
        } else {
          return item;
        }
      };
      extension = getExtension(type);
      plugin = plugins.filter(function(plugin) {
        return plugin.extension === extension;
      })[0];
      dataGenerator = plugin != null ? (_ref1 = plugin.generators) != null ? (_ref2 = _ref1[framework]) != null ? _ref2[type] : void 0 : void 0 : void 0;
      data = configGenerator != null ? getData(configGenerator) : dataGenerator != null ? getData(dataGenerator) : '';
      getPaths = (_ref3 = getGeneratorMap()[framework]) != null ? _ref3[type] : void 0;
      paths = (typeof getPaths === "function" ? getPaths(name, pluralName) : void 0) || [];
      nonStrings = paths.filter(function(path) {
        return typeof path !== 'string';
      });
      strings = paths.filter(function(path) {
        return typeof path === 'string';
      }).map(function(path) {
        return path + ("." + extension);
      }).map(function(path) {
        var file;
        file = {
          type: type,
          extension: extension,
          path: path,
          data: data
        };
        logger.debug('info', "Scaffolding", file);
        return file;
      });
      return strings.concat(nonStrings);
    };
    return generator;
  };

  generateFile = function(path, data, callback) {
    var parentDir, write;
    parentDir = sysPath.dirname(path);
    write = function() {
      logger.info("create " + path);
      return fs.writeFile(path, data, callback);
    };
    return fs_utils.exists(parentDir, function(exists) {
      if (exists) {
        return write();
      }
      logger.info("init " + parentDir);
      return mkdirp(parentDir, 0x1ed, function(error) {
        if (error != null) {
          return logger.error;
        }
        return write();
      });
    });
  };

  destroyFile = function(path, callback) {
    return fs.unlink(path, function(error) {
      if (error != null) {
        return logger.error("" + error);
      }
      logger.info("destroy " + path);
      return callback(error);
    });
  };

  module.exports = scaffold = function(rollback, options, callback) {
    var configPath, generateOrDestroyFile, name, parentDir, pluralName, type;
    if (callback == null) {
      callback = (function() {});
    }
    type = options.type, name = options.name, pluralName = options.pluralName, parentDir = options.parentDir, configPath = options.configPath;
    pluralName = type === 'controller' || type === 'collection' ? name : inflection.pluralize(name, pluralName);
    if (name === pluralName) {
      if (type === 'controller' || type === 'collection' || type === 'scaffold') {
        name = inflection.singularize(pluralName);
      } else {
        return logger.error("Plural form must be declared for '" + name + "'");
      }
    }
    generateOrDestroyFile = function(file, callback) {
      if (rollback) {
        return destroyFile(file.path, callback);
      } else {
        return generateFile(file.path, file.data, callback);
      }
    };
    return helpers.loadPackages('.', function(error, packages) {
      var config, files, generator, plugins;
      if (error != null) {
        return logger.error(error);
      }
      config = helpers.loadConfig(configPath);
      if (config == null) {
        return callback();
      }
      plugins = helpers.getPlugins(packages, config);
      generator = getGenerator(config, plugins);
      files = generator(type, name, pluralName);
      return async.forEach(files, generateOrDestroyFile, function(error) {
        if (error != null) {
          return logger.error(error);
        }
        return callback(null, files);
      });
    });
  };

}).call(this);
