// Generated by CoffeeScript 1.3.3
(function() {
  'use strict';

  var Asset, common, helpers, logger, ncp, sysPath;

  sysPath = require('path');

  helpers = require('../helpers');

  logger = require('../logger');

  common = require('./common');

  ncp = require('ncp').ncp;

  module.exports = Asset = (function() {

    function Asset(path, config) {
      var directory,
        _this = this;
      this.path = path;
      directory = config.paths.assets.filter(function(dir) {
        return helpers.startsWith(path, dir);
      })[0];
      this.relativePath = sysPath.relative(directory, this.path);
      this.destinationPath = sysPath.join(config.paths["public"], this.relativePath);
      logger.debug('info', "Initializing fs_utils.Asset", {
        path: this.path,
        relativePath: this.relativePath,
        destinationPath: this.destinationPath
      });
      Object.freeze(this);
    }

    Asset.prototype.copy = function(callback) {
      return common.copy(this.path, this.destinationPath, callback);
    };

    return Asset;

  })();

}).call(this);
