// Generated by CoffeeScript 1.3.3
(function() {
  'use strict';

  var EventEmitter, fs, ignored, ignoredRe, logger, mkdirp, ncp, sysPath, util;

  fs = require('fs');

  EventEmitter = require('events').EventEmitter;

  mkdirp = require('mkdirp');

  ncp = require('ncp').ncp;

  sysPath = require('path');

  util = require('util');

  logger = require('../logger');

  exports.exists = fs.exists || sysPath.exists;

  exports.writeFile = function(path, data, callback) {
    var write;
    logger.debug('writer', "Writing file '" + path + "'");
    write = function(callback) {
      return fs.writeFile(path, data, callback);
    };
    return write(function(error) {
      if (error == null) {
        return callback(null, path, data);
      }
      return mkdirp(sysPath.dirname(path), 0x1ed, function(error) {
        if (error != null) {
          return callback(error);
        }
        return write(function(error) {
          return callback(error, path, data);
        });
      });
    });
  };

  ignoredRe = /(^[.#]|(?:__|~)$)/;

  exports.ignored = ignored = function(path) {
    return ignoredRe.test(sysPath.basename(path));
  };

  exports.copy = function(source, destination, callback) {
    var copy, parentDir;
    if (ignored(source)) {
      return callback();
    }
    copy = function(error) {
      var input, output;
      if (error != null) {
        return logger.error(error);
      }
      input = fs.createReadStream(source);
      output = fs.createWriteStream(destination);
      return util.pump(input, output, callback);
    };
    parentDir = sysPath.dirname(destination);
    return exports.exists(parentDir, function(exists) {
      if (exists) {
        return copy();
      } else {
        return mkdirp(parentDir, copy);
      }
    });
  };

  exports.copyIfExists = function(source, destination, filter, callback) {
    var options;
    if (filter == null) {
      filter = true;
    }
    options = filter ? {
      filter: (function(path) {
        return !ignored(path);
      })
    } : {};
    return exports.exists(source, function(exists) {
      if (!exists) {
        return callback();
      }
      return ncp(source, destination, options, callback);
    });
  };

}).call(this);
