// Generated by CoffeeScript 1.3.3
(function() {
  'use strict';

  var GeneratedFile, async, common, fs, getRequireDefinition, helpers, inflection, logger, sysPath, _getStaticFile,
    __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

  fs = require('fs');

  inflection = require('inflection');

  sysPath = require('path');

  async = require('async');

  common = require('./common');

  helpers = require('../helpers');

  logger = require('../logger');

  _getStaticFile = async.memoize(function(filename, callback) {
    var path;
    path = sysPath.join(__dirname, '..', '..', 'vendor', filename);
    return fs.readFile(path, function(error, result) {
      if (error != null) {
        return logger.error(error);
      }
      return callback(null, result.toString());
    });
  });

  getRequireDefinition = _getStaticFile.bind(null, 'require_definition.js');

  module.exports = GeneratedFile = (function() {

    function GeneratedFile(path, sourceFiles, config, minifiers) {
      var _ref,
        _this = this;
      this.path = path;
      this.sourceFiles = sourceFiles;
      this.config = config;
      this.type = this.sourceFiles.some(function(file) {
        return file.type === 'javascript';
      }) ? 'javascript' : 'stylesheet';
      this.minifier = minifiers.filter(function(minifier) {
        return minifier.type === _this.type;
      })[0];
      this.isTestFile = (_ref = this.path, __indexOf.call(helpers.findTestFiles(this.config), _ref) >= 0);
      Object.freeze(this);
    }

    GeneratedFile.prototype._extractOrder = function(files, config) {
      var types;
      types = files.map(function(file) {
        return inflection.pluralize(file.type);
      });
      return Object.keys(config.files).filter(function(key) {
        return __indexOf.call(types, key) >= 0;
      }).map(function(key) {
        return config.files[key].order;
      }).reduce(function(memo, array) {
        array || (array = {});
        return {
          before: memo.before.concat(array.before || []),
          after: memo.after.concat(array.after || []),
          vendorPaths: config.paths.vendor
        };
      }, {
        before: [],
        after: []
      });
    };

    GeneratedFile.prototype._sort = function(files) {
      var indexes, order, paths;
      paths = files.map(function(file) {
        return file.path;
      });
      indexes = {};
      files.forEach(function(file, index) {
        return indexes[file.path] = file;
      });
      order = this._extractOrder(files, this.config);
      return helpers.sortByConfig(paths, order).map(function(path) {
        return indexes[path];
      });
    };

    GeneratedFile.prototype._loadTestFiles = function(files) {
      return files.map(function(file) {
        return file.path;
      }).filter(function(path) {
        return /_test\.[a-z]+$/.test(path);
      }).map(function(path) {
        path = path.replace(RegExp('\\\\', 'g'), '/');
        return path.substring(0, path.lastIndexOf('.'));
      }).map(function(path) {
        return "window.require('" + path + "');";
      }).join('\n') + '\n';
    };

    GeneratedFile.prototype._join = function(files, callback) {
      var joined,
        _this = this;
      logger.debug('writer', "Joining files '" + (files.map(function(file) {
        return file.path;
      }).join(', ')) + "' to '" + this.path + "'");
      joined = files.map(function(file) {
        return file.cache.data;
      }).join('');
      if (this.type === 'javascript') {
        return getRequireDefinition(function(error, requireDefinition) {
          if (_this.isTestFile) {
            return callback(error, requireDefinition + joined + _this._loadTestFiles(files));
          } else {
            return callback(error, requireDefinition + joined);
          }
        });
      } else {
        return process.nextTick(function() {
          return callback(null, joined);
        });
      }
    };

    GeneratedFile.prototype._minify = function(data, callback) {
      var _ref;
      if (this.config.minify && (((_ref = this.minifier) != null ? _ref.minify : void 0) != null)) {
        return this.minifier.minify(data, this.path, callback);
      } else {
        return callback(null, data);
      }
    };

    GeneratedFile.prototype.write = function(callback) {
      var _this = this;
      return this._join(this._sort(this.sourceFiles), function(error, joined) {
        if (error != null) {
          return callback(error);
        }
        return _this._minify(joined, function(error, data) {
          if (error != null) {
            return callback(error);
          }
          return common.writeFile(_this.path, data, callback);
        });
      });
    };

    return GeneratedFile;

  })();

}).call(this);
